FLTK 1.4.4: Fl_Input_Choice Class Reference

FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_Input_Choice Class Reference

A combination of the input widget and a menu button. More...

Inheritance diagram for Fl_Input_Choice:

## Public Member Functions
void | add (const char *s)
| Adds an item to the menu.
int | changed () const
| Returns the combined changed() state of the input and menu button widget.
void | clear ()
| Removes all items from the menu.
void | clear_changed ()
| Clears the changed() state of both input and menu button widgets.
Fl_Boxtype | down_box () const
| Gets the box type of the menu button.
void | down_box (Fl_Boxtype b)
| Sets the box type of the menu button.
| Fl_Input_Choice (int X, int Y, int W, int H, const char *L=0)
| Creates a new Fl_Input_Choice widget using the given position, size, and label string.
Fl_Input * | input ()
| Returns a pointer to the internal Fl_Input widget.
const Fl_Menu_Item * | menu ()
| Gets the Fl_Menu_Item array used for the menu.
void | menu (const Fl_Menu_Item *m)
| Sets the Fl_Menu_Item array used for the menu.
Fl_Menu_Button * | menubutton ()
| Returns a pointer to the internal Fl_Menu_Button widget.
void | resize (int X, int Y, int W, int H) FL_OVERRIDE
| Resizes the Fl_Input_Choice widget.
void | set_changed ()
| Sets the changed() state of both input and menu button widgets to the specified value.
Fl_Color | textcolor () const
| Gets the Fl_Input text field's text color.
void | textcolor (Fl_Color c)
| Sets the Fl_Input text field's text color to `c`.
Fl_Font | textfont () const
| Gets the Fl_Input text field's font style.
void | textfont (Fl_Font f)
| Sets the Fl_Input text field's font style to `f`.
Fl_Fontsize | textsize () const
| Gets the Fl_Input text field's font size.
void | textsize (Fl_Fontsize s)
| Sets the Fl_Input text field's font size to `s`.
int | update_menubutton ()
| Updates the menubutton with the string value in Fl_Input.
const char * | value () const
| Returns the Fl_Input text field's current contents.
void | value (const char *val)
| Sets the Fl_Input text field's contents to `val`.
void | value (int val)
| Chooses item# `val` in the menu, and sets the Fl_Input text field to that value.
Public Member Functions inherited from Fl_Group
Fl_Widget *& | _ddfdesign_kludge ()
| This is for forms compatibility only.
void | add (Fl_Widget &)
| The widget is removed from its current group (if any) and then added to the end of this group.
void | add (Fl_Widget *o)
| See void Fl_Group::add(Fl_Widget &w).
void | add_resizable (Fl_Widget &o)
| Adds a widget to the group and makes it the resizable widget.
Fl_Widget *const * | array () const
| Returns a pointer to the array of children.
Fl_Group const * | as_group () const FL_OVERRIDE
Fl_Group * | as_group () FL_OVERRIDE
| Returns an Fl_Group pointer if this widget is an Fl_Group.
void | begin ()
| Sets the current group so you can build the widget tree by just constructing the widgets.
Fl_Widget * | child (int n) const
| Returns the n'th child.
int | children () const
| Returns how many child widgets the group has.
void | clear ()
| Deletes all child widgets from memory recursively.
unsigned int | clip_children ()
| Returns the current clipping mode.
void | clip_children (int c)
| Controls whether the group widget clips the drawing of child widgets to its bounding box.
virtual int | delete_child (int n)
| Removes the widget at `index` from the group and deletes it.
void | end ()
| Exactly the same as current(this->parent()).
int | find (const Fl_Widget &o) const
| See int Fl_Group::find(const Fl_Widget *w) const.
int | find (const Fl_Widget *) const
| Searches the child array for the widget and returns the index.
| Fl_Group (int, int, int, int, const char *=0)
| Creates a new Fl_Group widget using the given position, size, and label string.
void | focus (Fl_Widget *W)
void | forms_end ()
| This is for forms compatibility only.
int | handle (int) FL_OVERRIDE
| Handles the specified event.
void | init_sizes ()
| Resets the internal array of widget sizes and positions.
void | insert (Fl_Widget &, int i)
| The widget is removed from its current group (if any) and then inserted into this group.
void | insert (Fl_Widget &o, Fl_Widget *before)
| This does insert(w, find(before)).
void | remove (Fl_Widget &)
| Removes a widget from the group but does not delete it.
void | remove (Fl_Widget *o)
| Removes the widget `o` from the group.
void | remove (int index)
| Removes the widget at `index` from the group but does not delete it.
Fl_Widget * | resizable () const
| Returns the group's resizable widget.
void | resizable (Fl_Widget &o)
| Sets the group's resizable widget.
void | resizable (Fl_Widget *o)
| The resizable widget defines both the resizing box and the resizing behavior of the group and its children.
virtual | ~Fl_Group ()
| The destructor also deletes all the children.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual class Fl_Gl_Window const * | as_gl_window () const
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
virtual Fl_Window const * | as_window () const
void | bind_deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
void | bind_deimage (int f)
| Bind the inactive image to the widget, so the widget will delete the image when it is no longer needed.
void | bind_image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
void | bind_image (int f)
| Bind the image to the widget, so the widget will delete the image when it is no longer needed.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, Fl_Callback_User_Data *p, bool auto_free)
| Sets the current callback function and managed user data for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function and data for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label when in the inactive state.
const Fl_Image * | deimage () const
| Gets the image that is used as part of the widget label when in the inactive state.
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label when in the inactive state.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
int | deimage_bound () const
| Returns whether the inactive image is managed by the widget.
void | do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with default arguments.
void | do_callback (Fl_Widget *widget, long arg, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | do_callback (Fl_Widget *widget, void *arg=0, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual void | hide ()
| Makes a widget invisible.
int | horizontal_label_margin ()
| Get the spacing between the label and the horizontal edge of the widget.
void | horizontal_label_margin (int px)
| Set the spacing between the label and the horizontal edge of the widget.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label when in the active state.
const Fl_Image * | image () const
| Gets the image that is used as part of the widget label when in the active state.
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label when in the active state.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
int | image_bound () const
| Returns whether the image is managed by the widget.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
int | label_image_spacing ()
| Return the gap size between the label and the image.
void | label_image_spacing (int gap)
| Set the gap between the label and the image in pixels.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
bool | needs_keyboard () const
| Returns whether this widget needs a keyboard.
void | needs_keyboard (bool needs)
| Sets whether this widget needs a keyboard.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
int | shortcut_label () const
| Returns whether the widget's label uses '&' to indicate shortcuts.
void | shortcut_label (int value)
| Sets whether the widget's label uses '&' to indicate shortcuts.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (Fl_Callback_User_Data *v, bool auto_free)
| Sets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
int | vertical_label_margin ()
| Get the spacing between the label and the vertical edge of the widget.
void | vertical_label_margin (int px)
| Set the spacing between the label and the vertical edge of the widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus () const
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Protected Member Functions
void | draw () FL_OVERRIDE
| Draws the widget.
virtual int | inp_h () const
| See inp_x() for info.
virtual int | inp_w () const
| See inp_x() for info.
virtual int | inp_x () const
| The methods inp_x(), inp_y(), inp_w() and inp_h() return the desired position and size of the internal Fl_Input widget.
virtual int | inp_y () const
| See inp_x() for info.
virtual int | menu_h () const
| See menu_x() for info.
virtual int | menu_w () const
| See menu_x() for info.
virtual int | menu_x () const
| The methods menu_x(), menu_y(), menu_w() and menu_h() return the desired position and size of the internal Fl_Menu_Button widget.
virtual int | menu_y () const
| See menu_x() for info.
Protected Member Functions inherited from Fl_Group
Fl_Rect * | bounds ()
| Returns the internal array of widget sizes and positions.
void | draw_child (Fl_Widget &widget) const
| Forces a child to redraw.
void | draw_children ()
| Draws all children of the group.
void | draw_outside_label (const Fl_Widget &widget) const
| Parents normally call this to draw outside labels of child widgets.
virtual int | on_insert (Fl_Widget *, int)
| Allow derived groups to act when a widget is added as a child.
virtual int | on_move (int, int)
| Allow derived groups to act when a widget is moved within the group.
virtual void | on_remove (int)
| Allow derived groups to act when a child widget is removed from the group.
int * | sizes ()
| Returns the internal array of widget sizes and positions.
void | update_child (Fl_Widget &widget) const
| Draws a child only if it needs it.
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus () const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int X, int Y, int W, int H) const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color bg) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Group
static Fl_Group * | current ()
| Returns the currently active group.
static void | current (Fl_Group *g)
| Sets the current group.
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *widget, void *data)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , NEEDS_KEYBOARD = 1<<20 , IMAGE_BOUND = 1<<21 , DEIMAGE_BOUND = 1<<22 , AUTO_DELETE_USER_DATA = 1<<23 , MAXIMIZED = 1<<24 , POPUP = 1<<25 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

A combination of the input widget and a menu button.

The user can either type into the input area, or use the menu button chooser on the right to choose an item which loads the input area with the selected text.

The application can directly access both the internal Fl_Input and Fl_Menu_Button widgets respectively using the input() and menubutton() accessor methods.

The default behavior is to invoke the Fl_Input_Choice::callback() if the user changes the input field's contents, either by typing, pasting, or clicking a different item in the choice menu.

The callback can determine if an item was picked vs. typing into the input field by checking the value of menubutton()->changed(), which will be:

    - 1: the user picked a different item in the choice menu
    - 0: the user typed or pasted directly into the input field

Example Use of Fl_Input_Choice
  #include <stdio.h>
  #include <FL/Fl.H>
  #include <FL/Fl_Double_Window.H>
  #include <FL/Fl_Input_Choice.H>
  // Fl_Input_Choice callback()
  void choice_cb(Fl_Widget *w, void *userdata) {
  // Show info about the picked item
  Fl_Input_Choice *choice = (Fl_Input_Choice*)w;
  printf("*** Choice Callback:\n");
  printf(" widget's text value='%s'\n", choice->value()); // normally all you need
  // Access the menu via menubutton()..
  const Fl_Menu_Item *item = choice->menubutton()->mvalue();
  printf(" item label()='%s'\n", item ? item->label() : "(No item)");
  printf(" item value()=%d\n", choice->menubutton()->value());
  printf(" input value()='%s'\n", choice->input()->value());
  printf(" The user %s\n", choice->menubutton()->changed()
  ? "picked a menu item"
  : "typed text");
  }
  int main() {
  Fl_Double_Window win(200,100,"Input Choice");
  win.begin();
  Fl_Input_Choice choice(10,10,100,30);
  choice.callback(choice_cb, 0);
  choice.add("Red");
  choice.add("Orange");
  choice.add("Yellow");
  //choice.value("Red"); // uncomment to make "Red" default
  win.end();
  win.show();
  return Fl::run();
  }
  Fl.H
  Fl static class.
  Fl_Double_Window
  The Fl_Double_Window provides a double-buffered window.
  Definition Fl_Double_Window.H:31
  Fl_Input_Choice
  A combination of the input widget and a menu button.
  Definition Fl_Input_Choice.H:43
  Fl_Input_Choice::menubutton
  Fl_Menu_Button * menubutton()
  Returns a pointer to the internal Fl_Menu_Button widget.
  Definition Fl_Input_Choice.H:191
  Fl_Input_Choice::add
  void add(const char *s)
  Adds an item to the menu.
  Definition Fl_Input_Choice.H:114
  Fl_Input_Choice::value
  const char * value() const
  Returns the Fl_Input text field's current contents.
  Definition Fl_Input_Choice.H:159
  Fl_Input_Choice::Fl_Input_Choice
  Fl_Input_Choice(int X, int Y, int W, int H, const char *L=0)
  Creates a new Fl_Input_Choice widget using the given position, size, and label string.
  Definition Fl_Input_Choice.cxx:261
  Fl_Input_Choice::input
  Fl_Input * input()
  Returns a pointer to the internal Fl_Input widget.
  Definition Fl_Input_Choice.H:196
  Fl_Input_::value
  int value(const char *)
  Changes the widget text.
  Definition Fl_Input_.cxx:1461
  Fl_Widget::callback
  Fl_Callback_p callback() const
  Gets the current callback function for the widget.
  Definition Fl_Widget.H:740
  Fl_Widget::w
  void w(int v)
  Internal use only.
  Definition Fl_Widget.H:154
  Fl_Widget::changed
  unsigned int changed() const
  Checks if the widget value changed since the last callback.
  Definition Fl_Widget.H:996
  Fl::run
  static int run()
  Calls Fl::wait()repeatedly as long as any windows are displayed.
  Definition Fl.cxx:651

Subclassing Example
  One can subclass Fl_Input_Choice to override the virtual methods inp_x/y/w/h() and menu_x/y/w/h() to take control of the internal Fl_Input and Fl_Menu_Button widget positioning. In this example, input and menubutton's positions are swapped:
  #include <FL/Fl.H>
  #include <FL/Fl_Window.H>
  #include <FL/Fl_Input_Choice.H>
  class MyInputChoice : public Fl_Input_Choice {
  protected:
  virtual int inp_x() const { return x() + Fl::box_dx(box()) + menu_w(); } // override to reposition
  virtual int menu_x() const { return x() + Fl::box_dx(box()); } // override to reposition
  public:
  MyInputChoice(int X,int Y,int W,int H,const char*L=0) : Fl_Input_Choice(X,Y,W,H,L) {
  resize(X,Y,W,H); // necessary for ctor to trigger our overrides
  }
  };
  int main(int argc, char **argv) {
  Fl_Window *win = new Fl_Window(400,300);
  MyInputChoice *mychoice = new MyInputChoice(150,40,150,25,"Right Align Input");
  mychoice->add("Aaa");
  mychoice->add("Bbb");
  mychoice->add("Ccc");
  win->end();
  win->resizable(win);
  win->show();
  return Fl::run();
  }
  Fl_Window.H
  Fl_Window widget .
  Fl_Group::end
  void end()
  Exactly the same as current(this->parent()).
  Definition Fl_Group.cxx:73
  Fl_Group::resizable
  void resizable(Fl_Widget &o)
  Sets the group's resizable widget.
  Definition Fl_Group.H:156
  Fl_Input_Choice::menu_x
  virtual int menu_x() const
  The methods menu_x(), menu_y(), menu_w() and menu_h() return the desired position and size of the int...
  Definition Fl_Input_Choice.H:84
  Fl_Input_Choice::menu_w
  virtual int menu_w() const
  See menu_x() for info.
  Definition Fl_Input_Choice.H:88
  Fl_Input_Choice::resize
  void resize(int X, int Y, int W, int H) FL_OVERRIDE
  Resizes the Fl_Input_Choice widget.
  Definition Fl_Input_Choice.cxx:276
  Fl_Input_Choice::inp_x
  virtual int inp_x() const
  The methods inp_x(), inp_y(), inp_w() and inp_h() return the desired position and size of the interna...
  Definition Fl_Input_Choice.H:71
  Fl_Widget::box
  Fl_Boxtype box() const
  Gets the box type of the widget.
  Definition Fl_Widget.H:440
  Fl_Widget::x
  void x(int v)
  Internal use only.
  Definition Fl_Widget.H:150
  Fl_Window::show
  void show() FL_OVERRIDE
  Puts the window on the screen.
  Definition Fl_Window.cxx:546
  Fl::box_dx
  static int box_dx(Fl_Boxtype)
  Returns the X offset for the given boxtype.
  Definition fl_boxtype.cxx:379

## Constructor & Destructor Documentation

## ◆ Fl_Input_Choice()

Fl_Input_Choice::Fl_Input_Choice | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = 0 )

Creates a new Fl_Input_Choice widget using the given position, size, and label string.

Inherited destructor destroys the widget and any values associated with it.

## Member Function Documentation

## ◆ add()

void Fl_Input_Choice::add | ( | const char * | s | ) |
| inline

Adds an item to the menu.

When any item is selected, the Fl_Input_Choice callback() is invoked, which can do something with the selected item.

You can access the more complex Fl_Menu_Button::add() methods (setting item-specific callbacks, userdata, etc), via menubutton(). Example:

Fl_Input_Choice *choice = new Fl_Input_Choice(100,10,120,25,"Fonts");
Fl_Menu_Button *mb = choice->menubutton(); // use Fl_Input_Choice's Fl_Menu_Button
mb->add("Helvetica", 0, MyFont_CB, (void*)mydata); // use Fl_Menu_Button's add() methods
mb->add("Courier", 0, MyFont_CB, (void*)mydata);
mb->add("More..", 0, FontDialog_CB, (void*)mydata);

## ◆ draw()

void Fl_Input_Choice::draw | ( |  | ) |
| protectedvirtual

Draws the widget.

Never call this function directly. FLTK will schedule redrawing whenever needed. If your widget must be redrawn as soon as possible, call redraw() instead.

Override this function to draw your own widgets.

If you ever need to call another widget's draw method from within your own draw() method, e.g. for an embedded scrollbar, you can do it (because draw() is virtual) like this:

Fl_Widget *s = &scrollbar; // scrollbar is an embedded Fl_Scrollbar
s->draw(); // calls Fl_Scrollbar::draw()

Reimplemented from Fl_Group.

## ◆ inp_x()

virtual int Fl_Input_Choice::inp_x | ( |  | ) | const
| inlineprotectedvirtual

The methods inp_x(), inp_y(), inp_w() and inp_h() return the desired position and size of the internal Fl_Input widget.

These can be overridden by a subclass to redefine positioning. See code example in the Description for subclassing details.

## ◆ input()

Fl_Input * Fl_Input_Choice::input | ( |  | ) |
| inline

Returns a pointer to the internal Fl_Input widget.

This can be used to directly access all of the Fl_Input widget's methods.

## ◆ menu_x()

virtual int Fl_Input_Choice::menu_x | ( |  | ) | const
| inlineprotectedvirtual

The methods menu_x(), menu_y(), menu_w() and menu_h() return the desired position and size of the internal Fl_Menu_Button widget.

These can be overridden by a subclass to redefine positioning. See code example in the Description for subclassing details.

## ◆ menubutton()

Fl_Menu_Button * Fl_Input_Choice::menubutton | ( |  | ) |
| inline

Returns a pointer to the internal Fl_Menu_Button widget.

This can be used to access any of the methods of the menu button, e.g.

Fl_Input_Choice *choice = new Fl_Input_Choice(100,10,120,25,"Choice:");
[..]
// Print all the items in the choice menu
for ( int t=0; t<choice->menubutton()->size(); t++ ) {
const Fl_Menu_Item &item = choice->menubutton()->menu()[t];
printf("item %d -- label=%s\n", t, item.label() ? item.label() : "(Null)");
}
Fl_Widget::size
void size(int W, int H)
Changes the size of the widget.
Definition Fl_Widget.H:418

## ◆ resize()

void Fl_Input_Choice::resize | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H )
| virtual

Resizes the Fl_Input_Choice widget.

Reimplemented from Fl_Group.

## ◆ update_menubutton()

int Fl_Input_Choice::update_menubutton | ( |  | ) |

Updates the menubutton with the string value in Fl_Input.

If the string value currently in Fl_Input matches one of the menu items in menubutton(), that menu item will become the current item selected.

Call this method after setting value(const char*) if you need the menubutton() to be synchronized with the Fl_Input field.

// Add items
choice->add(".25");
choice->add(".50");
choice->add("1.0");
choice->add("2.0");
choice->add("4.0");
choice->value("1.0"); // sets Fl_Input to "1.0"
choice->update_menubutton(); // cause menubutton to reflect this value too
// (returns 1 if match was found, 0 if not)
// Verify menubutton()'s value.
printf("menu button choice index=%d, value=%s\n",
choice->menubutton()->value(), // would be -1 if update not done
choice->menubutton()->text()); // would be NULL if update not done

Returns
  1 if a matching menuitem was found and value set, 0 if not.

Version
  1.4.0

## ◆ value() [1/2]

void Fl_Input_Choice::value | ( | const char * | val | ) |
| inline

Sets the Fl_Input text field's contents to `val`.

Note it is possible to set the value() to one that is not in the menubutton's list of choices.

Setting the value() does NOT affect the menubutton's selection. If that's needed, call update_menubutton() after setting value().

See also
  void value(int val), update_menubutton()

## ◆ value() [2/2]

void Fl_Input_Choice::value | ( | int | val | ) |

Chooses item# `val` in the menu, and sets the Fl_Input text field to that value.

Any previous text is cleared.

See also
  void value(const char *val)

The documentation for this class was generated from the following files:

- Fl_Input_Choice.H
- Fl_Input_Choice.cxx